
If InitEngine3D(#PB_Engine3D_DebugLog) = 0
  MessageRequester("ERROR!", "Failed to initialize the 3D engine.", #PB_MessageRequester_Ok)
  End
EndIf

If InitSprite() = 0
  MessageRequester("ERROR!", "Failed to initialize the sprite environment.", #PB_MessageRequester_Ok)
  End
EndIf

If InitKeyboard() = 0
  MessageRequester("ERROR!", "Failed to initialize the keyboard environment.", #PB_MessageRequester_Ok)
  End
EndIf

Enumeration
  #Window
  #Camera
  #Node
  #Light
  #Sphere
  #ShaderEntity1
  #ShaderEntity2
  #RegularEntity1
  #RegularEntity2
  #ShaderMaterial1
  #ShaderMaterial2
  #RegularTexture1
  #RegularTexture2
  #RegularMaterial1
  #RegularMaterial2
EndEnumeration

ExamineDesktops()
DesktopW = DesktopWidth(0)
DesktopH = DesktopHeight(0)

If OpenWindow(#Window, 0, 0, DesktopW, DesktopH, "Black To Alpha Shader")
  If OpenWindowedScreen(WindowID(#Window), 0, 0, DesktopW, DesktopH)

    Add3DArchive("scripts/", #PB_3DArchive_FileSystem)
    Add3DArchive("shaders/", #PB_3DArchive_FileSystem)
    Add3DArchive("textures/", #PB_3DArchive_FileSystem)
    Parse3DScripts() ;We need to Parse the Archives when using scripts and shaders
    
    CreateSphere(#Sphere, 3, 64, 32)
    
    ;Load First Shader
    GetScriptMaterial(#ShaderMaterial1, "Transparent01")
    MaterialFilteringMode(#ShaderMaterial1, #PB_Material_None)
    MaterialCullingMode(#ShaderMaterial1, #PB_Material_NoCulling)
    
    ;Load Second Shader
    GetScriptMaterial(#ShaderMaterial2, "Transparent02")
    MaterialFilteringMode(#ShaderMaterial2, #PB_Material_None)
    MaterialCullingMode(#ShaderMaterial2, #PB_Material_NoCulling)
    
    ;Create First Shader Entity
    CreateEntity(#ShaderEntity1, MeshID(#Sphere), MaterialID(#ShaderMaterial1), -4, 0, -4)
    RotateEntity(#ShaderEntity1, 0, 180, 0)
    
    ;Create Second Shader Entity
    CreateEntity(#ShaderEntity2, MeshID(#Sphere), MaterialID(#ShaderMaterial2), -5, 0, 0)
    RotateEntity(#ShaderEntity2, 0, 180, 0)
    
    
    ;####
    ;The Materials and Entities Below are not using the shaders.
    ;They are just for a before and after effect.
    LoadTexture(#RegularTexture1, "Image01.png")
    CreateMaterial(#RegularMaterial1, TextureID(#RegularTexture1))
    MaterialFilteringMode(#RegularMaterial1, #PB_Material_None)
    
    LoadTexture(#RegularTexture2, "Image02.png")
    CreateMaterial(#RegularMaterial2, TextureID(#RegularTexture2))
    MaterialFilteringMode(#RegularMaterial2, #PB_Material_None)
    
    CreateEntity(#RegularEntity1, MeshID(#Sphere), MaterialID(#RegularMaterial1), 4, 0, -4)
    RotateEntity(#RegularEntity1, 0, 180, 0)
    
    CreateEntity(#RegularEntity2, MeshID(#Sphere), MaterialID(#RegularMaterial2), 5, 0, 0)
    RotateEntity(#RegularEntity2, 0, 180, 0)
    ;####
    
    
    CreateCamera(#Camera, 0, 0, 100, 100)
    MoveCamera  (#Camera, 0, 0, 20)
    CameraLookAt(#Camera, 0, 0, 0)
    CameraBackColor(#Camera, RGB(50, 100, 150))

    CreateLight(#Light, RGB(255,255,255), 5, 5, 5)
    
    CreateNode(#Node, 0, 0, 0)
    AttachNodeObject(#Node, CameraID(#Camera))
    
    Repeat
      
      Event = WindowEvent()
      
      If ExamineKeyboard()
        If KeyboardPushed(#PB_Key_Up)
          MoveCamera(#Camera, 0, 0, -0.2)
        ElseIf KeyboardPushed(#PB_Key_Down)
          MoveCamera(#Camera, 0, 0, 0.2)
        EndIf
        If KeyboardPushed(#PB_Key_Left)
          RotateNode(#Node, 0, -1, 0, #PB_Relative)
          CameraLookAt(#Camera, 0, 0, 0)
        ElseIf KeyboardPushed(#PB_Key_Right)
          RotateNode(#Node, 0, 1, 0, #PB_Relative)
          CameraLookAt(#Camera, 0, 0, 0)
        EndIf
        If KeyboardReleased(#PB_Key_W)
          CameraRenderMode(#Camera, #PB_Camera_Wireframe)
        ElseIf KeyboardReleased(#PB_Key_E)
          CameraRenderMode(#Camera, #PB_Camera_Textured)
        EndIf
      EndIf
  
      RenderWorld()
      FlipBuffers()

    Until Event = #PB_Event_CloseWindow Or KeyboardPushed(#PB_Key_Escape)
    
  EndIf
EndIf
End
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 38
; FirstLine = 30
; EnableXP
; CompileSourceDirectory